# struct Debug::ELF

- Debug::ELF
- Struct
- Value
- Object

##
Overview

ELF reader.

Documentation:

- <http://www.sco.com/developers/gabi/latest/contents.html>

##
Defined in:

##
Constant Summary

MAGIC = `UInt8.slice(127, 'E'.ord, 'L'.ord, 'F'.ord)`

##
Constructors

- .new(io : IO::FileDescriptor)

##
Class Method Summary

- .open(path, &)

##
Instance Method Summary

- #ehsize : UInt16
- #ehsize=(ehsize : UInt16)
- #ehsize? : UInt16?
- #entry : UInt32 | UInt64
- #entry=(entry : UInt32 | UInt64)
- #entry? : UInt32 | UInt64?
- #flags : UInt32
- #flags=(flags : UInt32)
- #flags? : UInt32?
- #ident : Ident
- #ident? : Ident?
- #machine : Machine
- #machine=(machine : Machine)
- #machine? : Machine?
- #phentsize : UInt16
- #phentsize=(phentsize : UInt16)
- #phentsize? : UInt16?
- #phnum : UInt16
- #phnum=(phnum : UInt16)
- #phnum? : UInt16?
- #phoff : UInt32 | UInt64
- #phoff=(phoff : UInt32 | UInt64)
- #phoff? : UInt32 | UInt64?
- #read_section?(name : String, &)

  Searches for a section then yield the `SectionHeader` and the IO object ready for parsing if the section was found.

- #section_headers

  Parses and returns an Array of `SectionHeader`.

- #sh_name(index)

  Returns the name of a section, using the `SectionHeader#name` index.

- #shentsize : UInt16
- #shentsize=(shentsize : UInt16)
- #shentsize? : UInt16?
- #shnum : UInt16
- #shnum=(shnum : UInt16)
- #shnum? : UInt16?
- #shoff : UInt32 | UInt64
- #shoff=(shoff : UInt32 | UInt64)
- #shoff? : UInt32 | UInt64?
- #shstrndx : UInt16
- #shstrndx=(shstrndx : UInt16)
- #shstrndx? : UInt16?
- #type : Type
- #type=(type : Type)
- #type? : Type?
- #version : UInt32
- #version=(version : UInt32)
- #version? : UInt32?

### Instance methods inherited from struct `Struct`

==(other) : Bool ==, hash(hasher) hash, inspect(io : IO) : Nil inspect, pretty_print(pp) : Nil pretty_print, to_s(io : IO) : Nil to_s

### Instance methods inherited from struct `Value`

==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, __crystal_pseudo_! : Bool __crystal_pseudo_!, __crystal_pseudo_as(type : Class) __crystal_pseudo_as, __crystal_pseudo_as?(type : Class) __crystal_pseudo_as?, __crystal_pseudo_is_a?(type : Class) : Bool __crystal_pseudo_is_a?, __crystal_pseudo_nil? : Bool __crystal_pseudo_nil?, __crystal_pseudo_responds_to?(name : Symbol) : Bool __crystal_pseudo_responds_to?, class class, dup dup, hash(hasher)
hash hash, inspect : String
inspect(io : IO) : Nil inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Constructor Detail

def self.new(io : IO::FileDescriptor) #

##
Class Method Detail

def self.open(path, &) #

##
Instance Method Detail

def ehsize : UInt16 #
def ehsize=(ehsize : UInt16) #
def ehsize? : UInt16? #
def entry : UInt32 | UInt64 #
def entry=(entry : UInt32 | UInt64) #
def entry? : UInt32 | UInt64? #
def flags : UInt32 #
def flags=(flags : UInt32) #
def flags? : UInt32? #
def ident : Ident #
def ident? : Ident? #
def machine : Machine #
def machine=(machine : Machine) #
def machine? : Machine? #
def phentsize : UInt16 #
def phentsize=(phentsize : UInt16) #
def phentsize? : UInt16? #
def phnum : UInt16 #
def phnum=(phnum : UInt16) #
def phnum? : UInt16? #
def phoff : UInt32 | UInt64 #
def phoff=(phoff : UInt32 | UInt64) #
def phoff? : UInt32 | UInt64? #
def read_section?(name : String, &) #

Searches for a section then yield the `SectionHeader` and the IO object ready for parsing if the section was found. Returns the valure returned by the block or nil if the section wasn't found.

def section_headers #

Parses and returns an Array of `SectionHeader`.

def sh_name(index) #

Returns the name of a section, using the `SectionHeader#name` index.

def shentsize : UInt16 #
def shentsize=(shentsize : UInt16) #
def shentsize? : UInt16? #
def shnum : UInt16 #
def shnum=(shnum : UInt16) #
def shnum? : UInt16? #
def shoff : UInt32 | UInt64 #
def shoff=(shoff : UInt32 | UInt64) #
def shoff? : UInt32 | UInt64? #
def shstrndx : UInt16 #
def shstrndx=(shstrndx : UInt16) #
def shstrndx? : UInt16? #
def type : Type #
def type=(type : Type) #
def type? : Type? #
def version : UInt32 #
def version=(version : UInt32) #
def version? : UInt32? #